if (!window.launchpad) {
    window.launchpad = {};
}
if (!window.launchpad.setpayload) {
    window.launchpad.setpayload = {};
}
App.dataTable.InvokeServiceForm.prototype.serviceMethodCallback=function(formInput) {
    return new Promise(reject => {
    try {
        this.prepareBody(formInput);
        if (this.inputParams.form.formCallback) {
            const callbackFn = App.Utils.stringToFunction(this.inputParams.form.formCallback,window);
            callbackFn.call(this,formInput);
        }
        const ajaxOptions = {
                    url: this.serverURL + this.inputParams.form.url,
                    contentType: 'application/json',
                    method: this.inputParams.form.method,
                    data: JSON.stringify(this.inputParams.form.body)
                };
                this.prepareHeader(ajaxOptions);
                App.ajax.call(ajaxOptions).then(this.successCallback).catch(reject);
            } catch (e) {
                App.log.error(e);
                throw e;
            }
        });
    }

App.dataTable.InvokeServiceForm.prototype.successCallback=function(response) {
        App.log.debug(response);
        this.form.modal.close();
        if (this.inputParams.refreshRows) {
            this.dataTable.refreshRowByObjectIds(this.selectedObjectIds);
        } else {
            this.widget.refreshToolbarAndWidget();
        }
        
        if (response.results === null) {
            if (response.status === 'success') {
                App.toaster.success(App.i18n.t(this.inputParams.form.successMessage));
            } else {
                App.toaster.warning("The object has not been changed ");
            }
        } else {
            if (response.results.length === 0) {
                App.toaster.warning("The object has not been changed ");
            } else {
                App.toaster.success(App.i18n.t(this.inputParams.form.successMessage));
            }
        }
    }


launchpad.setpayload = {
    
    setReservePayloadAfterForm:function(formInput){
        let choice=formInput[2].reserveField.values[0].value;
             
        let userSelectedRef=false;
        let userSelectedInstances=false;
        let isIdInserted=-1;
        
//OOTB reference ===> UPS : model/bus/.... OOTB instance ===> relationship : model/rel/...
        switch (choice) {
            case "INSTANCE":
                userSelectedRef=false;
                userSelectedInstances=true;
                break;
            case "REF":
                userSelectedRef=true;
                userSelectedInstances=false;
                break;
            case "REF|INSTANCE":
                userSelectedRef=true;
                userSelectedInstances=true;
                break;
            default:
                userSelectedRef=false;
                userSelectedInstances=false;
        }
        
        let data = this.dataTable.selectedRows();
        
        for (let iCounter = 0; iCounter < data.length; iCounter++) {
            if (userSelectedInstances) {
                if (this.dataTable.metadataMapping[data[iCounter].id].relationshipId != null) {
                    this.inputParams.form.body.urls.push(`model/rel/${this.dataTable.metadataMapping[data[iCounter].id].relationshipId}`);
                }
            }
            if (userSelectedRef) {
                isIdInserted = this.inputParams.form.body.urls.toString().search(this.dataTable.metadataMapping[data[iCounter].id].objectId);
                if ( isIdInserted === -1 ) {
                    this.inputParams.form.body.urls.push(`model/bus/${this.dataTable.metadataMapping[data[iCounter].id].objectId}`);
                }
            }
	    }
    },

    setDetachPayload:function(payload,response, resolve,reject){
        
        if (this.widget.selectedRowIdToObjectsId != null) {
            let relId = this.dataTable.metadataMapping[Object.keys(this.widget.selectedRowIdToObjectsId)].relationshipId;

            if (relId != null) {  //Object is parent
                let allReferencePhysicalIds = response[1].split('\x07');
                let allReferenceIds = response[2].split('\x07');

                for (let jj = 0; jj < allReferencePhysicalIds.length; jj++) {
                    if (relId === allReferencePhysicalIds[jj]) {
                        const newPayloadData = {
                            version: '1.0',
                            bAllOrNothing: false,
                            instances: [allReferenceIds[jj]]};                    
                    
                        payload = {
                            method: payload.method,
                            url: payload.url,
                            data: JSON.stringify(newPayloadData),
                            headers: payload.headers};
                        resolve(payload);
                        break;
                    }
                }
            } else {
                App.toaster.warning("In the given context, the object has no parent. The object will not be disconnected.");
                reject(response);
            }
        } else {
            App.toaster.warning("Incorrect data. The object will not be disconnected.");
            reject(response);
        }
    }
};